/* 
	FILE : HyperGlue.c
	BUILT: 12/19/88
	FONT : Profont fixed-cell 9 point (available on GEnie)
	FROM : GEnie A.COHEN6
	SOURCE: LightSpeed 'c' v3.0
	TARGET: Macintosh II

	Taken from Appendix A Pg. 250 of the Apple Hypercard Script Language Guide
	(c)Apple Computer, Inc.
*/

#ifndef	_HYPERCARD_
#include "HyperXCmd.h"
#endif


#ifndef _HYPERGLUE_
pascal void
SendCardMessage(paramPtr, msg)					/* Send a message to current CARD	*/
register	XCmdBlockPtr	paramPtr;
StringPtr	msg;
{
	paramPtr->inArgs[0]	= (long) msg;			/* set address of message			*/
	paramPtr->request	= xreqSendCardMessage;	/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Oh current card...				*/
}



pascal Handle
EvalExpr(paramPtr, expr)						/* Evaluate an expression			*/
register	XCmdBlockPtr	paramPtr;
StringPtr	expr;
{
	paramPtr->inArgs[0]	= (long) expr;			/* set address of expression		*/
	paramPtr->request	= xreqEvalExpr;			/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it!							*/
	return((Handle)paramPtr->outArgs[0]);		/* You get char *answer!			*/
}



pascal long
StringLength(paramPtr, strPtr)					/* Calculate string length			*/
register	XCmdBlockPtr	paramPtr;
StringPtr	strPtr;
{
	paramPtr->inArgs[0]	= (long) strPtr;		/* pointer to a 'c' format string	*/
	paramPtr->request	= xreqStringLength;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Measure it!						*/
	return((long)paramPtr->outArgs[0]);			/* You get the string length back!	*/
}



pascal Ptr
StringMatch(paramPtr, pattern, target)			/* Find a pattern					*/
register	XCmdBlockPtr	paramPtr;
StringPtr	pattern;
Ptr			target;
{
	paramPtr->inArgs[0]	= (long) pattern;		/* pointer to a pascal format string*/
	paramPtr->inArgs[1]	= (long) target;		/* pointer to a 'c' format string	*/
	paramPtr->request	= xreqStringMatch;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Do we have pattern in target?	*/
	return((Ptr)paramPtr->outArgs[0]);			/* NIL = no, else char *match string*/
}



pascal void
SendHCMessage(paramPtr, msg)					/* Send a message to HYPERCARD		*/
register	XCmdBlockPtr	paramPtr;
StringPtr	msg;
{
	paramPtr->inArgs[0]	= (long) msg;			/* pointer to a pascal format string*/
	paramPtr->request	= xreqSendHCMessage;	/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Oh Hypercard...					*/
}



pascal void
ZeroBytes(paramPtr, dstPtr, longCount)			/* Clear memory to ZERO				*/
register	XCmdBlockPtr	paramPtr;
Ptr			dstPtr;
long		longCount;
{
	paramPtr->inArgs[0]	= (long) dstPtr;		/* pointer to start of memory area	*/
	paramPtr->inArgs[1]	= longCount;			/* number of bytes to clear			*/
	paramPtr->request	= xreqZeroBytes;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Zappo!							*/
}



pascal Handle
PasToZero(paramPtr, pasStr)						/* Convert pascal string to c format*/
register	XCmdBlockPtr	paramPtr;
StringPtr	pasStr;
{
	paramPtr->inArgs[0]	= (long) pasStr;		/* pointer to pascal format string	*/
	paramPtr->request	= xreqPasToZero;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* convert it!						*/
	return((Handle)paramPtr->outArgs[0]);		/* You get a HANDLE to the c string */
}



pascal void
ZeroToPas(paramPtr, zeroStr, pasStr)			/* Convert c string to pascal format*/
register	XCmdBlockPtr	paramPtr;
char		*zeroStr;
StringPtr	pasStr;
{
	paramPtr->inArgs[0]	= (long) zeroStr;		/* pointer to area holding c string */
	paramPtr->inArgs[1]	= (long) pasStr;		/* pointer to area for pascal string*/
	paramPtr->request	= xreqZeroToPas;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* d d d d do it!					*/
}



pascal long
StrToLong(paramPtr, strPtr)						/* Convert ASCII to UNSIGNED long	*/
register	XCmdBlockPtr	paramPtr;
Str31		*strPtr;
{
	paramPtr->inArgs[0]	= (long) strPtr;		/* pointer to ASCII string			*/
	paramPtr->request	= xreqStrToLong;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* convert it please.				*/
	return((long)paramPtr->outArgs[0]);			/* thank'n you. (return answer)		*/
}



pascal long
StrToNum(paramPtr, str)							/* Convert ASCII to SIGNED long		*/
register	XCmdBlockPtr	paramPtr;
Str31		*str;
{
	paramPtr->inArgs[0]	= (long) str;			/* pointer to ASCII string			*/
	paramPtr->request	= xreqStrToNum;			/* set identifier					*/
	(*paramPtr->entryPoint)();					/* exchange please.					*/
	return((long)paramPtr->outArgs[0]);			/* i'll take a long.				*/
}



pascal Boolean
StrToBool(paramPtr, str)						/* Convert pascal true/false to bool*/
register	XCmdBlockPtr	paramPtr;
Str31		*str;
{
	paramPtr->inArgs[0]	= (long) str;			/* pointer to "true" or "false"		*/
	paramPtr->request	= xreqStrToBool;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* convert it!						*/
	return((Boolean)paramPtr->outArgs[0]);		/* return 1 or 0					*/
}



pascal void
StrToExt(paramPtr, str, myext)					/* Convert ASCII string to DOUBLE	*/
register	XCmdBlockPtr	paramPtr;
Str31		*str;
double		*myext;
{
	paramPtr->inArgs[0]	= (long) str;			/* pointer to the ASCII string		*/
	paramPtr->inArgs[1]	= (long) myext;			/* address of the receiving DOUBLE	*/
	paramPtr->request	= xreqStrToExt;			/* set identifier					*/
	(*paramPtr->entryPoint)();					/* hit a double!					*/
}



pascal void
LongToStr(paramPtr, posNum, mystr)				/* Convert UNSIGNED long to pascal	*/
register	XCmdBlockPtr	paramPtr;
long		posNum;
Str31		*mystr;
{
	paramPtr->inArgs[0]	= posNum;				/* the unsigned number				*/
	paramPtr->inArgs[1]	= (long) mystr;			/* pointer to your pascal string	*/
	paramPtr->request	= xreqLongToStr;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* welcome to pascal format			*/
}



pascal void
NumToStr(paramPtr, num, mystr)					/* Convert SIGNED long to pascal	*/
register	XCmdBlockPtr	paramPtr;
long		num;
Str31		*mystr;
{
	paramPtr->inArgs[0]	= num;					/* the signed number				*/
	paramPtr->inArgs[1]	= (long) mystr;			/* pointer to your pascal string	*/
	paramPtr->request	= xreqNumToStr;			/* set identifier					*/
	(*paramPtr->entryPoint)();					/* greetings in pascal				*/
}



pascal void
NumToHex(paramPtr, num, nDigits, mystr)			/* Convert UNSIGNED long to hex str */
register	XCmdBlockPtr	paramPtr;
long		num;
short		nDigits;
Str31		*mystr;
{
	paramPtr->inArgs[0]	= num;					/* the unsigned number				*/
	paramPtr->inArgs[1]	= nDigits;				/* number of digits (UNIX ecvt()??) */
	paramPtr->inArgs[2] = (long) mystr;			/* pointer to your pascal string	*/
	paramPtr->request	= xreqNumToHex;			/* set identifier					*/
	(*paramPtr->entryPoint)();					/* put the hex on.					*/
}



pascal void										/* Convert 1 or 0 to "true"/""false"*/
BoolToStr(paramPtr, bool, mystr)
register	XCmdBlockPtr	paramPtr;
Boolean		bool;
Str31		*mystr;
{
	paramPtr->inArgs[0]	= (long)bool;			/* the 1 or 0						*/
	paramPtr->inArgs[1]	= (long)mystr;			/* pointer to your pascal string	*/
	paramPtr->request	= xreqBoolToStr;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
}



pascal void
ExtToStr(paramPtr, myext, mystr)				/* Convert double to ASCII string	*/
register	XCmdBlockPtr	paramPtr;			/* Just like UNIX fltoa()			*/
double		*myext;
Str31		*mystr;
{
	paramPtr->inArgs[0]	= (long)myext;			/* address of the double			*/
	paramPtr->inArgs[1]	= (long)mystr;			/* pointer to your pascal string	*/
	paramPtr->request	= xreqExtToStr;			/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Whew! Another conversion!		*/
}



pascal Handle
GetGlobal(paramPtr, globName)					/* Get handle to 'c' string holding */
register	XCmdBlockPtr	paramPtr;			/* value of global variable.		*/
StringPtr	globName;
{
	paramPtr->inArgs[0]	= (long) globName;		/* pointer to pascal fmt global name*/
	paramPtr->request	= xreqGetGlobal;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* I'll take a global on rye...		*/
	return((Handle)paramPtr->outArgs[0]);		/* Ok, I'll settle for a handle		*/
}



pascal void										/* Set global value to that held in */
SetGlobal(paramPtr, globName, globValue)		/* a 'c' string.					*/
register	XCmdBlockPtr	paramPtr;
StringPtr	globName;
Handle		globValue;
{
	paramPtr->inArgs[0]	= (long) globName;		/* pointer to pascal fmt global name*/
	paramPtr->inArgs[1]	= (long) globValue;		/* pointer to 'c' fmt string value	*/
	paramPtr->request	= xreqSetGlobal;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* Presto-Chango					*/
}



pascal Handle									/* Get value of a field into 'c' fmt*/
GetFieldByName(paramPtr, cardFieldFlag, fieldName)/* based on field name			*/
register	XCmdBlockPtr	paramPtr;
Boolean		cardFieldFlag;
StringPtr	fieldName;
{
	paramPtr->inArgs[0]	= (long) cardFieldFlag;	/* see notes						*/
	paramPtr->inArgs[1]	= (long) fieldName;		/* pointer to pascal fmt field name */
	paramPtr->request	= xreqGetFieldByName;	/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
	return((Handle)paramPtr->outArgs[0]);		/* You get a handle to it.			*/
}



pascal Handle									/* Get value of a field into 'c' fmt*/
GetFieldByNum(paramPtr, cardFieldFlag, fieldNum)/* based on relative field number	*/
register	XCmdBlockPtr	paramPtr;
Boolean		cardFieldFlag;
short		fieldNum;
{
	paramPtr->inArgs[0]	= (long) cardFieldFlag;	/* see notes						*/
	paramPtr->inArgs[1]	= fieldNum;				/* the field number					*/
	paramPtr->request	= xreqGetFieldByNum;	/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
	return((Handle)paramPtr->outArgs[0]);		/* You get a handle to it.			*/
}



pascal Handle									/* Get value of a field into 'c' fmt*/
GetFieldByID(paramPtr, cardFieldFlag, fieldID)	/* based on specified field id		*/
register	XCmdBlockPtr	paramPtr;
Boolean		cardFieldFlag;
short		fieldID;
{
	paramPtr->inArgs[0]	= (long) cardFieldFlag;	/* see notes						*/
	paramPtr->inArgs[1]	= fieldID;				/* the field ID						*/
	paramPtr->request	= xreqGetFieldByID;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
	return((Handle)paramPtr->outArgs[0]);		/* You get a handle to it.			*/
}



pascal void										/* Set value of a field specified by*/
SetFieldByName(paramPtr, cardFieldFlag, fieldName, fieldVal)/* name in pascal string*/
register	XCmdBlockPtr	paramPtr;
Boolean		cardFieldFlag;
StringPtr	fieldName;
Handle		fieldVal;
{
	paramPtr->inArgs[0]	= (long) cardFieldFlag;	/* see notes						*/
	paramPtr->inArgs[1]	= (long) fieldName;		/* pointer to pascal fmt field name */
	paramPtr->inArgs[2] = (long) fieldVal;		/* Handle to 'c' fmt value for field*/
	paramPtr->request	= xreqSetFieldByName;	/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
}



pascal void										/* Set value of a field specified by*/
SetFieldByNum(paramPtr, cardFieldFlag, fieldNum, fieldVal)/* card-relative number	*/
register	XCmdBlockPtr	paramPtr;
Boolean		cardFieldFlag;
short		fieldNum;
Handle		fieldVal;
{
	paramPtr->inArgs[0]	= (long) cardFieldFlag;	/* see notes						*/
	paramPtr->inArgs[1]	= fieldNum;				/* the field number					*/
	paramPtr->inArgs[2] = (long) fieldVal;		/* Handle to the 'c' fmt new value	*/
	paramPtr->request	= xreqGetFieldByNum;	/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
}



pascal void										/* Set value of a field specified by*/
SetFieldByID(paramPtr, cardFieldFlag, fieldID, fieldVal)/* the actual field id		*/
register	XCmdBlockPtr	paramPtr;
Boolean		cardFieldFlag;
short		fieldID;
Handle		fieldVal;
{
	paramPtr->inArgs[0]	= (long) cardFieldFlag;	/* see notes						*/
	paramPtr->inArgs[1]	= fieldID;				/* the field id						*/
	paramPtr->inArgs[2] = (long) fieldVal;		/* Handle to the 'c' fmt new value	*/
	paramPtr->request	= xreqSetFieldByID;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* do it.							*/
}



pascal Boolean									/* Compare 2 strings.  Return true  */
StringEqual(paramPtr, str1, str2)				/* if they are the same				*/
register	XCmdBlockPtr	paramPtr;
Str31			*str1, *str2;
{
	paramPtr->inArgs[0]	= (long) str1;			/* pointer to string 1 structure	*/
	paramPtr->inArgs[1]	= (long) str2;			/* pointer to string 2 structure	*/
	paramPtr->request	= xreqStringEqual;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* compare							*/
	return((Boolean)paramPtr->outArgs[0]);		/* return the result				*/
}



pascal void										/* Build a pascal string from 'c'fmt*/
ReturnToPas(paramPtr, zeroStr, pasStr)			/* string expected to end with CR	*/
register	XCmdBlockPtr	paramPtr;
Ptr			zeroStr;
StringPtr	pasStr;
{
	paramPtr->inArgs[0]	= (long) zeroStr;		/* pointer to 'c' fmt string		*/
	paramPtr->inArgs[1]	= (long) pasStr;		/* pointer to pascal string to build*/
	paramPtr->request	= xreqReturnToPas;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* gobble up to CR, or \0 if no CR	*/
}



pascal void										/* Set given pointer to next locatn */
ScanToReturn(paramPtr, scanHndl)				/* of either CR or \0 in 'c' string	*/
register	XCmdBlockPtr	paramPtr;
Ptr			*scanHndl;
{
	paramPtr->inArgs[0]	= (long) scanHndl;		/* pointer to starting location		*/
	paramPtr->request	= xreqScanToReturn;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* scan it.							*/
}



pascal void										/* Set given pointer to next locatn */
ScanToZero(paramPtr, scanHndl)					/* of \0 in a (should be) 'c' string*/
register	XCmdBlockPtr	paramPtr;
Ptr			*scanHndl;
{
	paramPtr->inArgs[0]	= (long) scanHndl;		/* pointer to starting location		*/
	paramPtr->request	= xreqScanToZero;		/* set identifier					*/
	(*paramPtr->entryPoint)();					/* scan it.							*/
}

#endif

#define _HYPERGLUE_